module 'emop.compile' [InterfaceCacheRef, ConsultedRef, HasWarningRef, TempDir, BuildDirOptionRef, UseCacheRef, DoNotBuildWithWarningRef, VerboseRef, DepsRef, WamPatchRef, RuntimeRef, SizeRec, PrologOptionsRef] {
   constructor: print/1,flush_output/0,emop_call/3,var/1,g_inc/3,catch/3,initialization/0,callable/2,number/1,g_assign/2,g_read/2,main/0,name/3,cmdline/0,error/2,none/0,true/0,file/0,file/2,emop_call/0,some/2,'mod'/0,call/0,pos/0,clause/4,failure/0,write/1,lexing_error/0,error/1,parsing_error/0,unescaped/0,operator/0,empty/2,callable/5,file/1,expand_error/0, dep/2, directive/1.

   runtime = RuntimeRef.

   build_dir = BuildDirOptionRef:get match ('some'(BuildDir) -> BuildDir).

   set_build_dir(BuildDirOption) :-
      BuildDirOptionRef:set(BuildDirOption).

   temp_dir(TempDir) :-
      (
         data.var:check(TempDir)
      ->
         TempDir = io.dir:mktemp,
         sys.process:at_exit() {
            do :-
               io.dir:delete_tree(TempDir)
         }
      ;
         true
      ).

   use_cache(Pos) :-
      UseCache = UseCacheRef:get,
      (
         UseCache = 'always'
      ->
         true
      ;
         Pos \= 'cmdline'
      ->
         UseCache = 'no_cmdline'
      ).

   set_use_cache(UseCache) :-
      UseCacheRef:set(UseCache).

   do_not_build_with_warning :-
      DoNotBuildWithWarningRef:get('true').

   set_do_not_build_with_warning(DoNotBuildWithWarning) :-
      DoNotBuildWithWarningRef:set(DoNotBuildWithWarning).

   verbose :-
      VerboseRef:get('true').

   set_verbose(Verbose) :-
      VerboseRef:set(Verbose).

   deps :-
      DepsRef:get('true').

   set_deps(Deps) :-
      DepsRef:set(Deps).

   wam_patch :-
      WamPatchRef:get('true').

   set_wam_patch(WamPatch) :-
      WamPatchRef:set(WamPatch).

   size(SizeId, Size) :-
      Size = SizeRec:{SizeId},
      (
         data.var:check(Size)
      ->
         throw('error'('unknown_size', 'set_size'))
      ;
         true
      ).

   prolog_options = PrologOptionsRef.

   log(Msg, Args) :-
      (
         verbose
      ->
         io.err:format(Msg, Args)
      ;
         true
      ).



%   test(Modules, Output) :-
%      module MakeInitCall [] {
%         do(_, ModList, InitGoal) :-
%            InitPos = callable(initialization, []),
%            'data.list':length(ModList, Count),
%            ExceptionVarCounter = 'data.ref.backtrackable':new(0),
%            InitGoal0 =
%               'emop.writer':callable(
%                  g_assign(
%                     'emop.writer':callable('success_test_count'), number(0)
%                  )
%               ),
%            (InitGoal1, _) =
%               'data.list':fold_left(ModList, (InitGoal0, 0)) [
%                  InitPos, Count, ExceptionVarCounter
%               ] {
%                  do((_, ModId), (OldInitGoal, Index), (NewInitGoal, 'data.number':succ(Index))) :-
%                     Exception =
%                        'data.atom':format(
%                           'E_~d', [data.number.(ExceptionVarCounter++)]
%                        ),
%                     NewInitGoal = 'emop.writer':sequence(
%                        [
%                           OldInitGoal,
%                           'emop.writer':callable(
%                              print(
%                                 'emop.writer':callable(
%                                    'data.atom':format(
%                                       'Testing \'~a\' (~d/~d)... ',
%                                       [ModId, Index, Count]
%                                    )
%                                 )
%                              )
%                           ),
%                           'emop.writer':callable(flush_output),
%                           'emop.writer':callable(
%                              catch(
%                                 'emop.writer':condition(
%                                    'emop.writer':callable(
%                                       emop_call(
%                                          'emop.writer':callable(ModId),
%                                          'emop.writer':callable('test'),
%                                          'emop.writer':callable(InitPos)
%                                       )
%                                    ),
%                                    'emop.writer':sequence(
%                                       [
%                                          'emop.writer':callable(
%                                             print(
%                                                'emop.writer':callable('succeed.\n')
%                                             )
%                                          ),
%                                          'emop.writer':callable(
%                                             g_inc(
%                                                'emop.writer':callable('success_test_count'),
%                                                var('_'),
%                                                var('_')
%                                             )
%                                          )
%                                       ]
%                                    ),
%                                    'emop.writer':callable(
%                                       print('emop.writer':callable('failed.\n'))
%                                    )
%                                 ),
%                                 var(Exception),
%                                 'emop.writer':sequence(
%                                    [
%                                       'emop.writer':callable(
%                                          print('emop.writer':callable('exception: '))
%                                       ),
%                                       'emop.writer':callable(
%                                          print(var(Exception))
%                                       ),
%                                       'emop.writer':callable(
%                                          print('emop.writer':callable('.\n'))
%                                       )
%                                    ]
%                                 )
%                              )
%                           )
%                        ]
%                     )
%               },
%            InitGoal =
%               'emop.writer':sequence(
%                  [
%                     InitGoal1,
%                     'emop.writer':callable(
%                        g_read(
%                           'emop.writer':callable('success_test_count'),
%                           var(SuccessCount)
%                        )
%                     ),
%                     'emop.writer':callable(print(var(SuccessCount))),
%                     'emop.writer':callable(
%                        print(
%                           'data.atom':format(
%                              '/~d tests passed.',
%                              [Count]
%                           )
%                        )
%                     )
%                  ]
%               ).
%      },
%      compile(Modules, BaseFilename, FilenamePl, MakeInitCall),
%      (
%         Output = 'atom.concat'(BaseFilename, '.test')
%      ->
%         true
%      ;
%         true
%      ),
%      link(Output, [FilenamePl]).



   gplc(FilenamePl, Mode, FilenameWam) :-
      log('Compiling \'~a\'...\n', [FilenameWam]),
      (
         sys.process:spawn(
            'gplc',
            [
               Mode,
               '-o',
               FilenameWam,
               FilenamePl
            ]
         )
      ->
         true
      ;
         throw(error('Compilation failed', cmdline))
      ).

   patch_wam(FilenameWam, FilenameWamPatched) :-
      log('Patching \'~a\'...\n', [FilenameWamPatched]),
      (
         OriginalFile = io.file:open_read(FilenameWam),
         NewFile = io.file:open_write(FilenameWamPatched),
         Patcher = emop.patch_wam:make() {
            do(
               ['get_atom'('$cut', R), 'cut'(_) | Tail],
               ['cut'('x'(R))],
               Tail
            ).
            do(
               ['cut'(V), 'put_atom'('$cut', R) | Tail],
               ['put_value'(V, R)],
               Tail
            ).
         },
         Patcher:stream(OriginalFile, NewFile),
         NewFile:close,
         OriginalFile:close
      ->
         true
      ;
         throw(error('Patching WAM file failed', cmdline))
      ).

   compile(Modules, Output) :-
      compile(Modules, _, _, Output).

   compile(Modules, ObjectFileList, BuildOutput, Output) :-
      (
         Modules = []
      ->
         throw(error(('No module to compile'), 'cmdline'))
      ;
         true
      ),
      module MakeInitCall [] {
         do(MainModId, _) =
            callable(
               emop_call,
               [
                  callable(MainModId, []),
                  callable(main, []),
                  callable(initialization, [])
               ]
            ).
      },
      compile_file(Modules, Output, BuildOutput, MakeInitCall, ObjectFileList).

   build(Modules, Output) :-
      compile(Modules, ObjectFileList, Output, _TempOutput),
      (
         HasWarningRef:get('true'),
         do_not_build_with_warning
      ->
         throw(error('Building is disabled in presence of warnings.  Use option --ignore-warnings to force building.', cmdline))
      ;
         true
      ),
      link(Output, [runtime:get | ObjectFileList]).

   link(Output, PrologFiles) :-
      log('Building \'~a\'...\n', [Output]),
      (
         'sys.process':spawn(
            'gplc',
            [
               '--no-top-level',
               '--local-size',
               data.number:atom(size('local'):get),
               '--global-size',
               data.number:atom(size('global'):get),
               '--trail-size',
               data.number:atom(size('trail'):get),
               '--cstr-size',
               data.number:atom(size('cstr'):get),
               '-o',
               Output
            |
               data.list:append(prolog_options:get, PrologFiles)
            ]
         )
      ->
         true
      ;
         throw(error('Linking failed', cmdline))
      ).

   constructor: interface/5.

   read_interface(BaseFilename, FilenameMpl, Fid, Deps, ModuleList, Sgn, ObjectFilename, ExpandDeps, MpiChange) :-
      use_cache('dummy'),
      InterfaceCacheRef:get(InterfaceCache),
      (
         data.list:member('interface'(FilenameMpl, Fid, Deps, ModuleList, Sgn, ObjectFilename, ExpandDeps, MpiChange), InterfaceCache)
      ->
         true
      ;
         FilenameMpi = filename_mpi(BaseFilename, Fid),
         ObjectFilename = filename_o(BaseFilename, Fid),
         catch(
            (
               MplChange = sys.file:last_modification(FilenameMpl),
               MpiChange = sys.file:last_modification(FilenameMpi),
               ObjectChange = sys.file:last_modification(ObjectFilename),
               data.term:(MplChange < MpiChange),
               data.term:(MplChange < ObjectChange)
            ),
            'error'('system_error'(_), _),
            fail
         ),
         log('Read interface \'~a\'...\n', [FilenameMpi]),
         FileMpi = io.file:open_read(FilenameMpi),
         FileMpi:read_term(interface(Fid, ExpandDeps, Deps, ModuleList, Sgn)),
         FileMpi:close,
         InterfaceCacheRef:set(['interface'(FilenameMpl, Fid, Deps, ModuleList, Sgn, ObjectFilename, ExpandDeps, MpiChange) | InterfaceCache])
      ).

   temp_filename(Fid, Suffix) =
      data.path:concat(temp_dir, data.atom:concat(Fid, Suffix)).

   build_filename(BaseFilename, Fid, Suffix) =
      (
         BuildDir = build_dir
      ->
         data.path:concat(BuildDir, data.atom:concat(Fid, Suffix))
      ;
         data.atom:concat(BaseFilename, Suffix)
      ).

   filename_pl(Fid) = temp_filename(Fid, '.pl').

   filename_link_pl(Fid) = temp_filename(Fid, '.link.pl').

   filename_link_wam(Fid) = temp_filename(Fid, '.link.wam').

   filename_mpi(BaseFilename, Fid) = build_filename(BaseFilename, Fid, '.mpi').

   filename_unpatched_wam(Fid) = temp_filename(Fid, '.unpatched.wam').

   filename_wam(Fid) = temp_filename(Fid, '.wam').

   filename_o(BaseFilename, Fid) = build_filename(BaseFilename, Fid, '.o').

   try_open(Filename, S) :-
      catch(
         io.file:open_read(Filename, S),
         error('existence_error'(_, _), _),
         fail
      ).

   lookup_file(RelFilename, Filename, S) :-
      (
         data.list:member(Path, paths),
         catch(
            (
               Filename = sys.file:real(data.path:concat(Path, RelFilename)),
               try_open(Filename, S)
            ),
            _E,
            fail
         )     
      ->
         true
      ;
         'data.atom':format('Unable to find \'~a\'', [RelFilename], Message),
         throw('error'(Message, 'cmdline'))
      ).

   lookup(ModSpec, Pos, BaseFilename, FilenameMpl, SMpl) :-
      (
         (
            ModSpec = 'file'(ModName)
         ->
            FilenameMpl = sys.file:real(ModName),
            catch(
               io.file:open_read(FilenameMpl, SMpl),
               _,
               fail
            )
         ;
            ModSpec = 'name'(ModName, PackageNodes, RootPackagePath)
         ->
            module_filename(ModName, Pos, RelBaseFilename),
            (
               data.list:longuest_prefix(Prefix, PackageNodes),
               data.path:(
                  join(Prefix, RelPath),
                  concat(RootPackagePath, RelPath, Path),
                  concat(Path, RelBaseFilename, BaseFilename0)
               )
            ;
               data.list:member(Path, paths),
               data.path:concat(Path, RelBaseFilename, BaseFilename0)
            ),
            catch(
               (
                  FilenameMpl = sys.file:real(data.atom:concat(BaseFilename0, '.mpl')),
                  io.file:open_read(FilenameMpl, SMpl)
               ),
               _,
               fail
            )
         ),
         data.atom:sub(FilenameMpl, 0, _, 4, BaseFilename)
      ->
         true
      ;
         (
            ModSpec = 'file'(ModName)
         ->
            true
         ;
            ModSpec = 'name'(ModName, PackageNodes, RootPackagePath)
         ),
         data.atom:format('Unable to find \'~a\'', [ModName], Message),
         throw(error(Message, Pos))
      ).

   module_filename(Mod, Pos, Filename) :-
      'data.atom':string(Mod, Str),
      module Change [] {
         do('.', '/') :- !.
         do('/', _) :- fail.
         do(C, C).
      },
      (
         'data.list':iter(Str, Change, FilenameStr)
      ->
         'data.string':atom(FilenameStr, Filename)
      ;
         'data.atom':format('Invalid module name \'~a\'', [Mod], Message),
         throw(error(Message, Pos))
      ).

   lib_dir =
      (ExecDir = data.path:base(sys.file:real(sys.process:exec_filename))) >>
      data.path:concat(data.path:base(ExecDir), 'lib').

   paths(Paths) :-
      (
         Path = 'sys.env':({'EMOPPATH'})
      ->
         data.atom:split(Path, data.path:separator, EnvPaths)
      ;
         EnvPaths = []
      ),
      'data.list':append(EnvPaths, [lib_dir], Paths).

   read_interface_expand(BaseFilename, FilenameMpl, Fid, Deps, ModuleList, Sgn, ObjectFilename, PackageNodes, RootPackagePath) :-
      read_interface(BaseFilename, FilenameMpl, Fid, Deps, ModuleList, Sgn, ObjectFilename, ExpandDeps, MpiChange),
      split_fid(Fid, none, BaseFilename, PackageNodes, RootPackagePath),
      data.list:iter(ExpandDeps) {
         do(Mod) :-
            lookup(
               'name'(Mod, PackageNodes, RootPackagePath),
               none,
               _BaseFilename,
               Filename
            ):close,
            catch(
               DepChange = sys.file:last_modification(Filename),
               'error'('system_error'(_), _),
               fail
            ),
            data.term:(DepChange < MpiChange).
      }.

   split_fid(Fid, FidPos, BaseFilename, PackageNodes, RootPackagePath) :-
      data.atom:split(Fid, '.', FidNodes),
      data.list:append(PackageNodes, [_], FidNodes),
      data.path:join(PackageNodes, RelRootPackagePath),
      (
         data.atom:concat(
            RootPackagePath,
            RelRootPackagePath,
            data.path:base(BaseFilename)
         )
      ->
         true
      ;
         throw(error('Invalid file module name', FidPos))
      ).

   generate_init_goal(InitList, InitGoal) :-
      InitGoalRef = data.ref.backtrackable:new(callable(true, [])),
      InitializedRef = data.ref.backtrackable:new([]),
      data.list:reverse_iter(InitList) {
         add(Fid) :-
            InitGoalRef:set(
               callable(
                  ',', [
                     InitGoalRef:get,
                     callable(data.atom:concat(Fid, '@init'), [])
                  ]
               )
            ).

         add_recursive(Fid, Deps) :-
            Initialized = InitializedRef:get,
            (
               data.list:member(Fid, Initialized)
            ->
               true
            ;
               InitializedRef:set([Fid | Initialized]),
               data.list:iter(Deps) {
                  do(dep(Dependency, _)) :-
                     (
                        data.list:member('init'(Dependency, Pos, Deps'), InitList)
                     ->
                        (
                           Pos \= cmdline
                        ->
                           add_recursive(Dependency, Deps')
                        ;
                           true
                        )
                     ).
               },
               add(Fid)
            ).

         do('init'(Fid, _, Deps)) :-
            add_recursive(Fid, Deps).
      },
      InitGoal = InitGoalRef:get.

   assert_call_redirect(ModuleList) :-
      (
         data.list:member(LocalId, ModuleList),
         ModTerm = data.term:make(LocalId, [Env]),
         ModCall = data.term:make(LocalId, [F, Env, Pos, CutLevel]),
         top:asserta(
            ':-'(
               'emop_dyn_call_to'(ModTerm, F, Pos, CutLevel),
               ','('!', ModCall)
            )
         ),
         fail
      ;
         true
      ).

   generate_static(ModuleList) =
      data.list:iter(ModuleList) {
         do(LocalId) =
            callable('emop_static', [callable(LocalId, [])])
      }.

   generate_call_redirect(ModuleList) =
      data.list:iter(ModuleList) {
         do(LocalId) =
            callable(
               ':-',
               [
                  callable(
                     'emop_call_to',
                     [
                        callable(LocalId, [var('$env')]),
                        var('$f'), var('$pos'), var('$CutLevel')
                     ]
                  ),
                  callable(
                     ',',
                     [
                        callable('!', []),
                        callable(
                           LocalId,
                           [
                              var('$f'),
                              var('$env'), var('$pos'), var('$CutLevel')
                           ]
                        )
                     ]
                  )
               ]
            ).
      }.

   import: io.null.

   solve_deps(Deps, Checked, Update, PackageNodes, RootPackagePath, Goals) :-
      Goals = data.list:morph(Deps) {
         do(dep(Dependency, Pos)) =
            require(Dependency, Checked, Pos, Update, PackageNodes, RootPackagePath)
      }.

   require(Mod, Checked, Pos, Update, PackageNodes, RootPackagePath, Goals) :-
      (
         top:emop_static(Mod)
      ->
         Goals = []
      ;
         consult_dyn(Mod, Checked, Pos, Update, PackageNodes, RootPackagePath, Goals)
      ).

   consult(Mod, Checked, Pos, Update, PackageNodes, RootPackagePath, Goals) :-
      (
         top:emop_static(Mod)
      ->
         throw('error'('static_module'(Mod), Pos))
      ;
         consult_dyn(Mod, Checked, Pos, Update, PackageNodes, RootPackagePath, Goals)
      ).

   consult_dyn(Mod, Checked, Pos, Update, PackageNodes, RootPackagePath, Goals) :-
      (
         data.list:member(Mod, Checked)
      ->
         Goals = []
      ;
         Consulted = ConsultedRef:get,
         (
            data.list:select('c'(Mod, ConsultDate, Deps), Consulted, Consulted0)
         ->
            HasBeenConsulted = 'yes'
         ;
            HasBeenConsulted = 'no',
            Consulted0 = Consulted
         ),
         (
            HasBeenConsulted = 'yes',
            ConsultDate = 'top'
         ->
            Goals = []
         ;
            SMpl = lookup(
               'name'(Mod, PackageNodes, RootPackagePath),
               Pos, _BaseFilename, FilenameMpl
            ),
            MplChange = sys.file:last_modification(FilenameMpl),
            (
               (
                  HasBeenConsulted = 'yes'
               ->
                  (
                     data.term:(ConsultDate < MplChange)
                  ->
                     (
                        Update:update(FilenameMpl)
                     ->
                        fail
                     ;
                        ConsultedRef:set(['c'(Mod, MplChange, Deps) | Consulted0])
                     )
                  ;
                     fail
                  )
               ;
                  fail
               )
            ->
               Goals = Tail,
               SMpl:close
            ;
               ConsultedRef:set(['c'(Mod, MplChange, Deps) | Consulted0]),
               reconsult(Mod, FilenameMpl, SMpl, PackageNodes, RootPackagePath, Deps, InitPred),
               Goals = [InitPred | Tail]
            ),
            solve_deps(Deps, [Mod | Checked], Update, PackageNodes, RootPackagePath, Tail)
         )
      ).

   find_fid(callable(F, operator, [A, B], _, _), Fid, FidPos) :-
      (F = ','; F = ';'; F = '->'),
      !,
      (
         find_fid(A, Fid, FidPos)
      ->
         true
      ;
         find_fid(B, Fid, FidPos)
      ).
   find_fid('()'(Sub, _, _), Fid, FidPos) :-
      find_fid(Sub, Fid, FidPos).
   find_fid('module'('atom'(Atom, Escaped, Pb, Pe), _Env, _Body, _Sgn, _Clauses, _Pb, _Pe), Fid, FidPos) :-
      (
         emop.parser:is_variable(Atom, Escaped, none)
      ->
         fail
      ;
         Fid = Atom,
         FidPos = file(Pb, Pe)
      ).

   reconsult(Mod, FilenameMpl, SMpl, PackageNodes, RootPackagePath, Deps, InitPred) :-
      Ast = emop.parser:parse_file(FilenameMpl, SMpl, 'emop.sgn'),
      (
         find_fid(Ast, Fid, _FidPos)
      ->
         true
      ;
         throw(error('No file module', file(FilenameMpl)))
      ),
      (
         Fid = Mod
      ->
         true
      ;
         throw(error(data.atom:format('Module name mismatch ~a and ~a', [Fid, Mod]), file(FilenameMpl)))
      ),
      FreeVars = emop.parse:fv(Ast),
      SgnVars = data.record:{},
      Dependencies = emop.expand:fresh_dependencies(PackageNodes, RootPackagePath),
      initial_scope(Dependencies, Scope),
      (
         emop.expand:expand_file(Fid, _Sgn, FilenameMpl, io.null, Dependencies).(
            Goal =
              expand_goal(Ast, Scope, SgnVars, FreeVars, 'singleton_warning'),
            close(ModuleList, Clauses0)
         )
      ->
         true
      ;
         throw(error(expand_error))
      ),
      SMpl:close,
      InitPred = data.atom:format('emop_init_~a', [Mod]),
      Clauses = [clause(InitPred, 0, [], Goal) | Clauses0],
      DynBaseName = data.atom:format('dyn$~a', [Mod]),
      clauses_to_prolog(Clauses, DynBaseName, FilenamePl),
      prolog_to_wam(DynBaseName, FilenamePl, '-w', Wam),
      top:load([Wam]),
      assert_call_redirect(ModuleList),
      Deps = Dependencies:get.

   check_user_defined(Fid, FidPos) :-
      (      
         data.list:member('c'(Fid, _, _), ConsultedRef:get)
      ->
         throw(error(data.atom:format('A module ~a has already been loaded.', [Fid]), FidPos))
      ;
         top:emop_static(Fid)
      ->
         throw(error(data.atom:format('A module ~a has been statically compiled.', [Fid]), FidPos))
      ;
         true
      ).

   load_ast(Ast, Update, ExternVars, SgnVars, Scope, Vars, M) :-
      Vars = data.list:merge(ExternVars, emop.parse:fv(Ast), data.term),
      Dependencies = emop.expand:fresh_dependencies([], '.'),
      (
         find_fid(Ast, Fid, FidPos)
      ->
         check_user_defined(Fid, FidPos)
      ;
         Fid = '$toplevel'
      ),
      emop.expand:expand_file(Fid, Sgn, '', io.null, Dependencies).(
         expand_goal(Ast, Scope, SgnVars, Vars, 'no_singleton_warning', Goal),
         close(ModuleList, Clauses0)
      ),
      (
         Fid = '$toplevel'
      ->
         true
      ;
         emop.sgn:add_consult_sgn(Fid, Sgn),
         ConsultedRef:set(['c'(Fid, 'top', []) | ConsultedRef:get])
      ),
      VarVars = data.list:iter(Vars, 'var'(<, >)),
      VarTerm = callable('vars', VarVars),
      Clauses = [
         clause('emop_toplevel_goal_init', 1, [VarTerm], Goal)
         | Clauses0
      ],
      clauses_to_prolog(Clauses, '$toplevel', FilenamePl),
      prolog_to_wam('$toplevel', FilenamePl, '-w', Wam),
      top:load([Wam]),
      assert_call_redirect(ModuleList),
      solve_deps(Dependencies:get, [], Update, [], '.', Goals),
      module M [Goals] {
         do(Vars) :-
            data.list:iter(Goals) {
               do(Goal) :-
                  top:call(Goal).
            },
            top:call('emop_toplevel_goal_init'(Vars)).
      }.

   import(Ast, Pb, Pe, Update, ExternVars, SgnVars, Scope, NewScope, NewVars, M) :-
      Pos = 'file'(Pb, Pe),
      Dependencies = emop.expand:fresh_dependencies([], '.'),
      (
         find_fid(Ast, Fid, FidPos)
      ->
         check_user_defined(Fid, FidPos)
      ;
         Fid = '$toplevel'
      ),
      emop.expand:expand_file(Fid, Sgn, '', io.null, Dependencies, ExpandFile),
      (
         Fid = '$toplevel'
      ->
         true
      ;
         emop.sgn:add_consult_sgn(Fid, Sgn),
         ConsultedRef:set(['c'(Fid, 'top', []) | ConsultedRef:get])
      ),
      ExpandFile:expand_import(Ast, Pos, ExternVars, SgnVars, Scope, Goals),
      VarTerm = callable('vars', VarVars),
      's'(Clauses, Inits, _, NewScope, NewVars) = data.list:fold_left(Goals, 's'(Clauses0, [], 0, Scope, ExternVars)) [SgnVars, Pos, ExpandFile, VarTerm] {
         do('import'(H, S, Goal), 's'(ClauseList, Acc, Counter, Scope, Vars)) =
            (
               F = data.atom:format('emop_toplevel_goal_init~d', [Counter]),
               (
                  H = var(HV)
               ->
                  SgnVars:{HV} = S,
                  (
                     data.list:member(HV, Vars)
                  ->
                     NewVars = Vars
                  ;
                     NewVars = [HV | Vars]
                  )
               ;
                  NewVars = Vars
               )
            ) >>
            's'(
               [
                  clause(F, 1, [VarTerm], Goal)
               |
                  ClauseList
               ],
               [F | Acc],
               data.number:succ(Counter),
               [ ExpandFile:get_scope(H, Pos, SgnVars, Scope) | Scope ],
               NewVars
            ).
      },
      VarVars = data.list:iter(NewVars, 'var'(<, >)),
      ExpandFile:close(ModuleList, Clauses0),
      clauses_to_prolog(Clauses, '$toplevel', FilenamePl),
      prolog_to_wam('$toplevel', FilenamePl, '-w', Wam),
      top:load([Wam]),
      assert_call_redirect(ModuleList),
      solve_deps(Dependencies:get, [], Update, [], '.', Goals),
      module M [Inits, Goals] {
         do(Params) :-
            data.list:iter(Goals) {
               do(Goal) :-
                  top:call(Goal).
            },
            data.list:iter(Inits) {
               do(F) :-
                  top:call(data.term:make(F, [Params])).
            }.
      }.

   clauses_to_prolog(Clauses, Fid, FilenamePl) :-
      SortedClauses = 'data.list':quick_sort(Clauses) [] {
         compare(directive(_), clause(_, _, _, _), '<') :- !.
         compare(clause(_, _, _, _), directive(_), '>') :- !.
         compare(directive(_), directive(_), '=') :- !.
         compare(clause(AF, AN, _, _), clause(BF, BN, _, _), R) :-
            !,
            data.term:compare((AF, AN), (BF, BN), R).
      },
      BuiltClauses = 'data.list':iter(SortedClauses) [] {
         do(clause(F, _, Args, B), R) :-
            R = callable(':-', [callable(F, Args), B]).
            do(directive(X)) =
               callable(':-', [X]).
      },
      filename_pl(Fid, FilenamePl),
      io.file:open_write(FilenamePl, FilePl),
      (
         emop.writer:write_clauses(FilePl, BuiltClauses)
      ->
         true
      ;
         throw(write(failure))
      ),
      FilePl:close.

   generate_object_file(Clauses, BaseFilename, Fid, ObjectFilename) :-
      clauses_to_prolog(Clauses, Fid, FilenamePl),
      prolog_to_object(BaseFilename, Fid, FilenamePl, ObjectFilename).

   constructor: symbol/5.

   initial_scope(Dependencies, Scope) :-
      SyntaxSgn = Dependencies:find_mod_sgn('emop.syntax', file('')),
      (
         data.var:check(SyntaxSgn)
      ->
         throw(error('EMoP syntax not found', file('')))
      ;
         true
      ),
      (
         data.list:member(
            symbol('syntax', 1, 'predicate', SyntaxInfo, _),
            SyntaxSgn
         )
      ->
         true
      ;
         throw(error('EMoP syntax not found', file('')))
      ),
      SyntaxEnv = data.record:{},
      emop.expand:get_args_info(
         SyntaxInfo, SyntaxSgn, SyntaxEnv, [], Dependencies, file(''), ['emop.syntax'], [var('syntax')]
      ),
      VAS = SyntaxEnv:{'syntax'},
      (
         data.var:check(VAS)
      ->
         throw(error('EMoP syntax not found', file('')))
      ;
         VAR = emop.unionfind:get_root(VAS),
         'root'((Fids, TrueSyntaxSgn)) = VAR:get
      ),
      Dependencies:add_expand(Fids, file('')),
      Scope = [
         emop.expand:make_scope(callable('emop.syntax', []), TrueSyntaxSgn, [])
      ].

   prolog_to_object(BaseFilename, Fid, FilenamePl, FilenameO) :-
      filename_o(BaseFilename, Fid, FilenameO),
      (
         wam_patch
      ->
         prolog_to_patched_wam(Fid, FilenamePl, '-W', FilenameWam),
         gplc(FilenameWam, '-c', FilenameO)
      ;
         gplc(FilenamePl, '-c', FilenameO)
      ).

   prolog_to_patched_wam(Fid, FilenamePl, Mode, FilenameWam) :-
      filename_unpatched_wam(Fid, FilenameUnpatchedWam),
      gplc(FilenamePl, Mode, FilenameUnpatchedWam),
      filename_wam(Fid, FilenameWam),
      patch_wam(FilenameUnpatchedWam, FilenameWam).

   prolog_to_wam(Fid, FilenamePl, Mode, FilenameWam) :-
      (
         wam_patch
      ->
         prolog_to_patched_wam(Fid, FilenamePl, Mode, FilenameWam)
      ;
         filename_wam(Fid, FilenameWam),
         gplc(FilenamePl, Mode, FilenameWam)
      ).

   compile_file(Modules, Output, BuildOutput, MakeInitCall, ObjectFileList) :-
      'data.ref.non_backtrackable':(
         new(none, MainModRef),
         new([], IncludedRef),
         new([], QueuedRef),
         new([], InitRef),
         new([], ModuleListRef),
         new([], FidListRef),
         new([], ObjectFileListRef)
      ),
      module Compiler [
         Compiler,
         MainModRef,
         IncludedRef,
         QueuedRef,
         InitRef,
         ModuleListRef,
         FidListRef,
         PackageNodes,
         RootPackagePath,
         MakeInitCall,
         ObjectFileListRef,
         HasWarningRef,
      ] {
         queue(ModSpec, Pos) :-
            QueuedRef:get(Queued),
            QueuedRef:set([(ModSpec, Pos) | Queued]).

         dequeue(ModSpec, Pos) :-
            QueuedRef:get([(ModSpec, Pos) | QueuedTail]),
            QueuedRef:set(QueuedTail).

         compile_all :-
            (
               repeat,
               (
                  dequeue(ModId, Pos)
               ->
                  (
                     compile(ModId, Pos)
                  ->
                     fail
                  ;
                     throw('big problem')
                  )
               ;
                  true
               )
            ->
               true
            ).

         runtime_error(PrintGoal, ExitGoal) =
%            callable(
%               ',',
%               [
%                  callable(
%                     'open',
%                     [
%                        callable('/dev/fd/2', []),
%                        callable('write', []),
%                        var('$stderr')
%                     ]
%                  ),
                  callable(
                     ',',
                     [
                        PrintGoal,
                        ExitGoal
                     ]
%                  )
%               ]
            ).

         protect_goal(Msg, Goal, ExitGoal) =
            callable(
               'catch',
               [
                  callable(
                     ';',
                     [
                        Goal,
                        runtime_error(
                           callable(
                              'print',
                              [
                                 callable('user_error', []),
                                 callable(data.atom:format('[~a]\n', [data.atom:format(Msg, ['failure'])]), [])
                              ]
                           ),
                           ExitGoal
                        )
                     ]
                  ),
                  var('$exc'),
                  runtime_error(
                     callable(
                        'format',
                        [
                           callable('user_error', []),
                           callable(data.atom:format('[~a] ~~q\n', [data.atom:format(Msg, ['exception'])]), []),
                           callable(
                              '.',
                              [
                                 var('$exc'),
                                 callable('[]', [])
                              ]
                           )
                        ]
                     ),
                     ExitGoal
                  )
               ]
            ).

         generate_link(MainModId, LinkObjectFilename) :-
            ModInitGoal = generate_init_goal(InitRef:get),
            ModuleList = ModuleListRef:get,
            Clauses1 = generate_call_redirect(ModuleList),
            Clauses0 = generate_static(FidListRef:get),
            Clauses = data.list:append(Clauses0, Clauses1),
            EmopCallArgs = [var(mod), var(call), var(pos), var('$CutLevel')],
            UnkErr0 = callable('unknown_module', []),
            UnkE = callable('throw', [callable('error', [UnkErr0, var(pos)])]),
            Unk = callable(
               ':-',
               [
                  callable('emop_dyn_call_to', EmopCallArgs),
                  UnkE
               ]
            ),
            Dyn = callable(
               ':-',
               [
                  callable('emop_call_to', EmopCallArgs),
                  callable('emop_dyn_call_to', EmopCallArgs)
               ]
            ),
            DynCallToDir = 'term'(':-'('dynamic'('/'('emop_dyn_call_to', 4)))),
            All = data.list:append([DynCallToDir | Clauses], [Dyn, Unk]),
            InitGoal =
               protect_goal(
                  'Uncaught ~a in initialization',
                  callable(
                     ',',
                     [
                        ModInitGoal,
                        protect_goal(
                           'Uncaught ~a',
                           MakeInitCall:do(MainModId, IncludedRef:get),
                           'term'('emop_call'('sys.process', 'exit'(0), 'init'))
                        )
                     ]
                  ),
                  'term'('halt'(1))
               ),
            InitDir = callable(':-', [callable('initialization', [InitGoal])]),
            Mod = [InitDir | All],
            io.file:open_write(LinkObjectFilename, FilePl),
            (
               'emop.writer':write_clauses(FilePl, Mod)
            ->
               true
            ;
               throw(write(failure))
            ),
            FilePl:close,
            ObjectFileListRef:set([LinkObjectFilename | ObjectFileListRef:get]).

         compile(ModSpec, Pos) :-
            lookup(
               ModSpec,
               Pos,
               BaseFilename,
               FilenameMpl,
               SMpl
            ),
            IncludedRef:get(Included),
            (
               data.list:member((BaseFilename, Fid), Included)
            ->
               SMpl:close
            ;
               (
                  deps
               ->
                  io.std:print_endline(FilenameMpl)
               ;
                  true
               ),
               (
                  use_cache(Pos),
                  read_interface_expand(BaseFilename, FilenameMpl, Fid, Deps, ModuleList, Sgn, ObjectFilename, PackageNodes, RootPackagePath)
               ->
                  true
               ;
                  recompile(BaseFilename, FilenameMpl, SMpl, Fid, Deps, ModuleList, Sgn, ObjectFilename, PackageNodes, RootPackagePath)
               ),
               ChangedDate = sys.file:last_modification(FilenameMpl),
               emop.sgn:cache(FilenameMpl, ChangedDate, Sgn),
               IncludedRef:set([(BaseFilename, Fid) | Included]),
               ModuleListRef:set(data.list:append(ModuleList, ModuleListRef:get)),
               FidListRef:set([Fid | FidListRef:get]),
               data.list:iter(Deps) [
                  Compiler,
                  PackageNodes,
                  RootPackagePath
               ] {
                  do(dep(Dependency, Pos)) :-
                     Compiler:queue(
                        name(Dependency, PackageNodes, RootPackagePath),
                        Pos
                     ).
               },
               SMpl:close,
               (
                  Pos = cmdline
               ->
                  MainModRef:set(some(Fid, BaseFilename))
               ;
                  true
               ),
               InitRef:set(['init'(Fid, Pos, Deps) | InitRef:get]),
               ObjectFileListRef:set([ObjectFilename | ObjectFileListRef:get])
            ).

         import: emop.sgn.

         recompile(BaseFilename, FilenameMpl, SMpl, Fid, Deps, ModuleList, Sgn, ObjectFilename, PackageNodes, RootPackagePath) :-
            emop.message:reset_warning,
            log('Processing \'~a\'...\n', [FilenameMpl]),
            Ast = emop.parser:parse_file(FilenameMpl, SMpl, 'emop.sgn'),
            (
               find_fid(Ast, Fid, FidPos)
            ->
               true
            ;
               throw(error('No file module', file(FilenameMpl)))
            ),
            data.atom:concat(BaseFilename, '.xml', FilenameXml),
            io.file:open_write(FilenameXml, FileXml),
            FileXml:print_endline('<?xml version="1.0"?>'),
            FileXml:print_endline('<!DOCTYPE file PUBLIC "-//INRIA//DTD EMoP Documentation//EN" "http://contraintes.inria.fr/emop/doc.dtd">'),
            FileXml:print_endline(
               '<file xmlns="http://contraintes.inria.fr/emop/doc">'
            ),
            split_fid(Fid, FidPos, BaseFilename, PackageNodes, RootPackagePath),
            FreeVars = emop.parse:fv(Ast),
            SgnVars = data.record:{},
            Dependencies = emop.expand:fresh_dependencies(PackageNodes, RootPackagePath),
            initial_scope(Dependencies, Scope),
            (
               emop.expand:expand_file(Fid, Sgn, FilenameMpl, FileXml, Dependencies).(
                  Goal =
                     expand_goal(Ast, Scope, SgnVars, FreeVars, 'singleton_warning'),
                  close(ModuleList, Clauses0)
               )
            ->
               true
            ;
               throw(error(expand_error))
            ),
            Deps = Dependencies:get,
            ExpandDeps = Dependencies:get_expand,
            data.atom:concat(Fid, '@init', InitF),
            Clauses = [clause(InitF, 0, [], Goal) | Clauses0],
            FileXml:print_endline('</file>'),
            FileXml:close,
            FilenameMpi = filename_mpi(BaseFilename, Fid),
            io.file:open_write(FilenameMpi, FileMpi),
            FileMpi:format('~q.\n', [interface(Fid, ExpandDeps, Deps, ModuleList, Sgn)]),
            FileMpi:close,
            (
               emop.message:has_warning
            ->
               HasWarningRef:set('true')
            ;
               true
            ),
            (
               emop.message:has_warning,
               do_not_build_with_warning
            ->
               true
            ;
               generate_object_file(Clauses, BaseFilename, Fid, ObjectFilename)
            ).
      },
      Compiler:queue(name('emop.syntax', [], ''), 'none'),
      Compiler:queue(name('io.stream', [], ''), 'none'),
      Compiler:queue(name('sys.process', [], ''), 'none'),
      data.list:reverse_iter(Modules) [Compiler] {
         do(Module) :-
            Compiler:queue(Module, cmdline).
      },
      Compiler:compile_all,
      some(MainModId, BaseFilename) = MainModRef:get,
      (
         data.var:check(Output)
      ->
         Output = filename_link_pl(MainModId)
      ;
         true
      ),
      (
         data.var:check(BuildOutput)
      ->
         BuildOutput = BaseFilename
      ;
         true
      ),
      Compiler:generate_link(MainModId, Output),
      ObjectFileList = ObjectFileListRef:get.      
},
HasWarningRef = data.ref.non_backtrackable:new('false'),
InterfaceCacheRef = data.ref.non_backtrackable:new([]),
ConsultedRef = data.ref.backtrackable:new([]),
BuildDirOptionRef = data.ref.backtrackable:new('none'),
UseCacheRef = data.ref.backtrackable:new('always'),
DoNotBuildWithWarningRef = data.ref.backtrackable:new('true'),
VerboseRef = data.ref.backtrackable:new('false'),
DepsRef = data.ref.backtrackable:new('false'),
WamPatchRef = data.ref.backtrackable:new('true'),
RuntimeRef = data.ref.backtrackable:new(_),
SizeRec = data.record:{},
SizeRec:{'global'} = data.ref.backtrackable:new(800000),
SizeRec:{'local'} = data.ref.backtrackable:new(100000),
SizeRec:{'cstr'} = data.ref.backtrackable:new(20000),
SizeRec:{'trail'} = data.ref.backtrackable:new(20000),
PrologOptionsRef = data.ref.backtrackable:new([])
